﻿-- brotherhobbes@gmail.com

assert( oRA, "oRA not found!")

------------------------------
--      Are you local?      --
------------------------------

local L = AceLibrary("AceLocale-2.2"):new("oRALDifficulty")

local raidDifficulties = {
	["10 Player"] = 1,
	["25 Player"] = 2,
	["10 Player (Heroic)"] = 3,
	["25 Player (Heroic)"] = 4,
}

----------------------------
--      Localization      --
----------------------------

L:RegisterTranslations("enUS", function() return {
	["Leader/Difficulty"] = true,
	["Raid Difficulty"] = true,
	["Options for raid difficulty."] = true,
	["Set the raid difficulty."] = true,
	["10 Player"] = true,
	["25 Player"] = true,
	["10 Player (Heroic)"] = true,
	["25 Player (Heroic)"] = true,
    ["<difficulty>"] = true,	
} end )

----------------------------------
--      Module Declaration      --
----------------------------------

local mod = oRA:NewModule("LeaderDifficulty")
mod.defaults = {
	difficulty = L["25 Player"],
}
mod.leader = true
mod.name = L["Leader/Difficulty"]
mod.consoleCmd = "difficulty"
mod.consoleOptions = {
	type = "text",
	name = L["Raid Difficulty"], desc = L["Set the raid difficulty."],
	disabled = function() return not oRA:IsActive() end,
	get = function() return mod.db.profile.difficulty end,
	set = function(v) 
		mod.db.profile.difficulty = v
		mod:SetRaidDifficulty()
	end,
	validate = { L["10 Player"], L["25 Player"], L["10 Player (Heroic)"], L["25 Player (Heroic)"] },
	usage = L["<difficulty>"],
}

------------------------------
--      Initialization      --
------------------------------

function mod:OnEnable()
	self:SetRaidDifficulty()
end

----------------------
-- Command handlers --
----------------------

function mod:SetRaidDifficulty()
	if not IsRaidLeader() then return end

	local difficulty = self.db.profile.difficulty

	if not (difficulty and L:HasReverseTranslation( difficulty ) and raidDifficulties[L:GetReverseTranslation(difficulty)]) then
		difficulty = self.defaults.difficulty
	end
	difficulty = raidDifficulties[L:GetReverseTranslation(difficulty)]	

	self:ScheduleEvent("oraraiddifficulty", SetRaidDifficulty, 3, difficulty)
end
